git-submodule.shon commit Git 2.8-rc3 (d9c691a)
   1#!/bin/sh
   2#
   3# git-submodule.sh: add, init, update or list git submodules
   4#
   5# Copyright (c) 2007 Lars Hjemli
   6
   7dashless=$(basename "$0" | sed -e 's/-/ /')
   8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
   9   or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
  10   or: $dashless [--quiet] init [--] [<path>...]
  11   or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
  12   or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
  13   or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
  14   or: $dashless [--quiet] foreach [--recursive] <command>
  15   or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
  16OPTIONS_SPEC=
  17SUBDIRECTORY_OK=Yes
  18. git-sh-setup
  19. git-sh-i18n
  20. git-parse-remote
  21require_work_tree
  22wt_prefix=$(git rev-parse --show-prefix)
  23cd_to_toplevel
  24
  25# Restrict ourselves to a vanilla subset of protocols; the URLs
  26# we get are under control of a remote repository, and we do not
  27# want them kicking off arbitrary git-remote-* programs.
  28#
  29# If the user has already specified a set of allowed protocols,
  30# we assume they know what they're doing and use that instead.
  31: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
  32export GIT_ALLOW_PROTOCOL
  33
  34command=
  35branch=
  36force=
  37reference=
  38cached=
  39recursive=
  40init=
  41files=
  42remote=
  43nofetch=
  44update=
  45prefix=
  46custom_name=
  47depth=
  48
  49# The function takes at most 2 arguments. The first argument is the
  50# URL that navigates to the submodule origin repo. When relative, this URL
  51# is relative to the superproject origin URL repo. The second up_path
  52# argument, if specified, is the relative path that navigates
  53# from the submodule working tree to the superproject working tree.
  54#
  55# The output of the function is the origin URL of the submodule.
  56#
  57# The output will either be an absolute URL or filesystem path (if the
  58# superproject origin URL is an absolute URL or filesystem path,
  59# respectively) or a relative file system path (if the superproject
  60# origin URL is a relative file system path).
  61#
  62# When the output is a relative file system path, the path is either
  63# relative to the submodule working tree, if up_path is specified, or to
  64# the superproject working tree otherwise.
  65resolve_relative_url ()
  66{
  67        remote=$(get_default_remote)
  68        remoteurl=$(git config "remote.$remote.url") ||
  69                remoteurl=$(pwd) # the repository is its own authoritative upstream
  70        url="$1"
  71        remoteurl=${remoteurl%/}
  72        sep=/
  73        up_path="$2"
  74
  75        case "$remoteurl" in
  76        *:*|/*)
  77                is_relative=
  78                ;;
  79        ./*|../*)
  80                is_relative=t
  81                ;;
  82        *)
  83                is_relative=t
  84                remoteurl="./$remoteurl"
  85                ;;
  86        esac
  87
  88        while test -n "$url"
  89        do
  90                case "$url" in
  91                ../*)
  92                        url="${url#../}"
  93                        case "$remoteurl" in
  94                        */*)
  95                                remoteurl="${remoteurl%/*}"
  96                                ;;
  97                        *:*)
  98                                remoteurl="${remoteurl%:*}"
  99                                sep=:
 100                                ;;
 101                        *)
 102                                if test -z "$is_relative" || test "." = "$remoteurl"
 103                                then
 104                                        die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
 105                                else
 106                                        remoteurl=.
 107                                fi
 108                                ;;
 109                        esac
 110                        ;;
 111                ./*)
 112                        url="${url#./}"
 113                        ;;
 114                *)
 115                        break;;
 116                esac
 117        done
 118        remoteurl="$remoteurl$sep${url%/}"
 119        echo "${is_relative:+${up_path}}${remoteurl#./}"
 120}
 121
 122# Resolve a path to be relative to another path.  This is intended for
 123# converting submodule paths when git-submodule is run in a subdirectory
 124# and only handles paths where the directory separator is '/'.
 125#
 126# The output is the first argument as a path relative to the second argument,
 127# which defaults to $wt_prefix if it is omitted.
 128relative_path ()
 129{
 130        local target curdir result
 131        target=$1
 132        curdir=${2-$wt_prefix}
 133        curdir=${curdir%/}
 134        result=
 135
 136        while test -n "$curdir"
 137        do
 138                case "$target" in
 139                "$curdir/"*)
 140                        target=${target#"$curdir"/}
 141                        break
 142                        ;;
 143                esac
 144
 145                result="${result}../"
 146                if test "$curdir" = "${curdir%/*}"
 147                then
 148                        curdir=
 149                else
 150                        curdir="${curdir%/*}"
 151                fi
 152        done
 153
 154        echo "$result$target"
 155}
 156
 157die_if_unmatched ()
 158{
 159        if test "$1" = "#unmatched"
 160        then
 161                exit 1
 162        fi
 163}
 164
 165#
 166# Print a submodule configuration setting
 167#
 168# $1 = submodule name
 169# $2 = option name
 170# $3 = default value
 171#
 172# Checks in the usual git-config places first (for overrides),
 173# otherwise it falls back on .gitmodules.  This allows you to
 174# distribute project-wide defaults in .gitmodules, while still
 175# customizing individual repositories if necessary.  If the option is
 176# not in .gitmodules either, print a default value.
 177#
 178get_submodule_config () {
 179        name="$1"
 180        option="$2"
 181        default="$3"
 182        value=$(git config submodule."$name"."$option")
 183        if test -z "$value"
 184        then
 185                value=$(git config -f .gitmodules submodule."$name"."$option")
 186        fi
 187        printf '%s' "${value:-$default}"
 188}
 189
 190isnumber()
 191{
 192        n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
 193}
 194
 195#
 196# Add a new submodule to the working tree, .gitmodules and the index
 197#
 198# $@ = repo path
 199#
 200# optional branch is stored in global branch variable
 201#
 202cmd_add()
 203{
 204        # parse $args after "submodule ... add".
 205        reference_path=
 206        while test $# -ne 0
 207        do
 208                case "$1" in
 209                -b | --branch)
 210                        case "$2" in '') usage ;; esac
 211                        branch=$2
 212                        shift
 213                        ;;
 214                -f | --force)
 215                        force=$1
 216                        ;;
 217                -q|--quiet)
 218                        GIT_QUIET=1
 219                        ;;
 220                --reference)
 221                        case "$2" in '') usage ;; esac
 222                        reference_path=$2
 223                        shift
 224                        ;;
 225                --reference=*)
 226                        reference_path="${1#--reference=}"
 227                        ;;
 228                --name)
 229                        case "$2" in '') usage ;; esac
 230                        custom_name=$2
 231                        shift
 232                        ;;
 233                --depth)
 234                        case "$2" in '') usage ;; esac
 235                        depth="--depth=$2"
 236                        shift
 237                        ;;
 238                --depth=*)
 239                        depth=$1
 240                        ;;
 241                --)
 242                        shift
 243                        break
 244                        ;;
 245                -*)
 246                        usage
 247                        ;;
 248                *)
 249                        break
 250                        ;;
 251                esac
 252                shift
 253        done
 254
 255        if test -n "$reference_path"
 256        then
 257                is_absolute_path "$reference_path" ||
 258                reference_path="$wt_prefix$reference_path"
 259
 260                reference="--reference=$reference_path"
 261        fi
 262
 263        repo=$1
 264        sm_path=$2
 265
 266        if test -z "$sm_path"; then
 267                sm_path=$(printf '%s\n' "$repo" |
 268                        sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
 269        fi
 270
 271        if test -z "$repo" || test -z "$sm_path"; then
 272                usage
 273        fi
 274
 275        is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
 276
 277        # assure repo is absolute or relative to parent
 278        case "$repo" in
 279        ./*|../*)
 280                test -z "$wt_prefix" ||
 281                die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
 282
 283                # dereference source url relative to parent's url
 284                realrepo=$(resolve_relative_url "$repo") || exit
 285                ;;
 286        *:*|/*)
 287                # absolute url
 288                realrepo=$repo
 289                ;;
 290        *)
 291                die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
 292        ;;
 293        esac
 294
 295        # normalize path:
 296        # multiple //; leading ./; /./; /../; trailing /
 297        sm_path=$(printf '%s/\n' "$sm_path" |
 298                sed -e '
 299                        s|//*|/|g
 300                        s|^\(\./\)*||
 301                        s|/\(\./\)*|/|g
 302                        :start
 303                        s|\([^/]*\)/\.\./||
 304                        tstart
 305                        s|/*$||
 306                ')
 307        git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
 308        die "$(eval_gettext "'\$sm_path' already exists in the index")"
 309
 310        if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
 311        then
 312                eval_gettextln "The following path is ignored by one of your .gitignore files:
 313\$sm_path
 314Use -f if you really want to add it." >&2
 315                exit 1
 316        fi
 317
 318        if test -n "$custom_name"
 319        then
 320                sm_name="$custom_name"
 321        else
 322                sm_name="$sm_path"
 323        fi
 324
 325        # perhaps the path exists and is already a git repo, else clone it
 326        if test -e "$sm_path"
 327        then
 328                if test -d "$sm_path"/.git || test -f "$sm_path"/.git
 329                then
 330                        eval_gettextln "Adding existing repo at '\$sm_path' to the index"
 331                else
 332                        die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
 333                fi
 334
 335        else
 336                if test -d ".git/modules/$sm_name"
 337                then
 338                        if test -z "$force"
 339                        then
 340                                echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
 341                                GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^,"  ", -e s,' (fetch)',, >&2
 342                                echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
 343                                echo >&2 "  $realrepo"
 344                                echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
 345                                die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
 346                        else
 347                                echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
 348                        fi
 349                fi
 350                git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" "$reference" "$depth" || exit
 351                (
 352                        clear_local_git_env
 353                        cd "$sm_path" &&
 354                        # ash fails to wordsplit ${branch:+-b "$branch"...}
 355                        case "$branch" in
 356                        '') git checkout -f -q ;;
 357                        ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
 358                        esac
 359                ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
 360        fi
 361        git config submodule."$sm_name".url "$realrepo"
 362
 363        git add $force "$sm_path" ||
 364        die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
 365
 366        git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
 367        git config -f .gitmodules submodule."$sm_name".url "$repo" &&
 368        if test -n "$branch"
 369        then
 370                git config -f .gitmodules submodule."$sm_name".branch "$branch"
 371        fi &&
 372        git add --force .gitmodules ||
 373        die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
 374}
 375
 376#
 377# Execute an arbitrary command sequence in each checked out
 378# submodule
 379#
 380# $@ = command to execute
 381#
 382cmd_foreach()
 383{
 384        # parse $args after "submodule ... foreach".
 385        while test $# -ne 0
 386        do
 387                case "$1" in
 388                -q|--quiet)
 389                        GIT_QUIET=1
 390                        ;;
 391                --recursive)
 392                        recursive=1
 393                        ;;
 394                -*)
 395                        usage
 396                        ;;
 397                *)
 398                        break
 399                        ;;
 400                esac
 401                shift
 402        done
 403
 404        toplevel=$(pwd)
 405
 406        # dup stdin so that it can be restored when running the external
 407        # command in the subshell (and a recursive call to this function)
 408        exec 3<&0
 409
 410        git submodule--helper list --prefix "$wt_prefix"|
 411        while read mode sha1 stage sm_path
 412        do
 413                die_if_unmatched "$mode"
 414                if test -e "$sm_path"/.git
 415                then
 416                        displaypath=$(relative_path "$sm_path")
 417                        say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
 418                        name=$(git submodule--helper name "$sm_path")
 419                        (
 420                                prefix="$prefix$sm_path/"
 421                                clear_local_git_env
 422                                cd "$sm_path" &&
 423                                sm_path=$(relative_path "$sm_path") &&
 424                                # we make $path available to scripts ...
 425                                path=$sm_path &&
 426                                if test $# -eq 1
 427                                then
 428                                        eval "$1"
 429                                else
 430                                        "$@"
 431                                fi &&
 432                                if test -n "$recursive"
 433                                then
 434                                        cmd_foreach "--recursive" "$@"
 435                                fi
 436                        ) <&3 3<&- ||
 437                        die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
 438                fi
 439        done
 440}
 441
 442#
 443# Register submodules in .git/config
 444#
 445# $@ = requested paths (default to all)
 446#
 447cmd_init()
 448{
 449        # parse $args after "submodule ... init".
 450        while test $# -ne 0
 451        do
 452                case "$1" in
 453                -q|--quiet)
 454                        GIT_QUIET=1
 455                        ;;
 456                --)
 457                        shift
 458                        break
 459                        ;;
 460                -*)
 461                        usage
 462                        ;;
 463                *)
 464                        break
 465                        ;;
 466                esac
 467                shift
 468        done
 469
 470        git submodule--helper list --prefix "$wt_prefix" "$@" |
 471        while read mode sha1 stage sm_path
 472        do
 473                die_if_unmatched "$mode"
 474                name=$(git submodule--helper name "$sm_path") || exit
 475
 476                displaypath=$(relative_path "$sm_path")
 477
 478                # Copy url setting when it is not set yet
 479                if test -z "$(git config "submodule.$name.url")"
 480                then
 481                        url=$(git config -f .gitmodules submodule."$name".url)
 482                        test -z "$url" &&
 483                        die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
 484
 485                        # Possibly a url relative to parent
 486                        case "$url" in
 487                        ./*|../*)
 488                                url=$(resolve_relative_url "$url") || exit
 489                                ;;
 490                        esac
 491                        git config submodule."$name".url "$url" ||
 492                        die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
 493
 494                        say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
 495                fi
 496
 497                # Copy "update" setting when it is not set yet
 498                if upd="$(git config -f .gitmodules submodule."$name".update)" &&
 499                   test -n "$upd" &&
 500                   test -z "$(git config submodule."$name".update)"
 501                then
 502                        case "$upd" in
 503                        checkout | rebase | merge | none)
 504                                ;; # known modes of updating
 505                        *)
 506                                echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
 507                                upd=none
 508                                ;;
 509                        esac
 510                        git config submodule."$name".update "$upd" ||
 511                        die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
 512                fi
 513        done
 514}
 515
 516#
 517# Unregister submodules from .git/config and remove their work tree
 518#
 519# $@ = requested paths (use '.' to deinit all submodules)
 520#
 521cmd_deinit()
 522{
 523        # parse $args after "submodule ... deinit".
 524        while test $# -ne 0
 525        do
 526                case "$1" in
 527                -f|--force)
 528                        force=$1
 529                        ;;
 530                -q|--quiet)
 531                        GIT_QUIET=1
 532                        ;;
 533                --)
 534                        shift
 535                        break
 536                        ;;
 537                -*)
 538                        usage
 539                        ;;
 540                *)
 541                        break
 542                        ;;
 543                esac
 544                shift
 545        done
 546
 547        if test $# = 0
 548        then
 549                die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
 550        fi
 551
 552        git submodule--helper list --prefix "$wt_prefix" "$@" |
 553        while read mode sha1 stage sm_path
 554        do
 555                die_if_unmatched "$mode"
 556                name=$(git submodule--helper name "$sm_path") || exit
 557
 558                displaypath=$(relative_path "$sm_path")
 559
 560                # Remove the submodule work tree (unless the user already did it)
 561                if test -d "$sm_path"
 562                then
 563                        # Protect submodules containing a .git directory
 564                        if test -d "$sm_path/.git"
 565                        then
 566                                echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
 567                                die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
 568                        fi
 569
 570                        if test -z "$force"
 571                        then
 572                                git rm -qn "$sm_path" ||
 573                                die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
 574                        fi
 575                        rm -rf "$sm_path" &&
 576                        say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
 577                        say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
 578                fi
 579
 580                mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
 581
 582                # Remove the .git/config entries (unless the user already did it)
 583                if test -n "$(git config --get-regexp submodule."$name\.")"
 584                then
 585                        # Remove the whole section so we have a clean state when
 586                        # the user later decides to init this submodule again
 587                        url=$(git config submodule."$name".url)
 588                        git config --remove-section submodule."$name" 2>/dev/null &&
 589                        say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
 590                fi
 591        done
 592}
 593
 594is_tip_reachable () (
 595        clear_local_git_env
 596        cd "$1" &&
 597        rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
 598        test -z "$rev"
 599)
 600
 601fetch_in_submodule () (
 602        clear_local_git_env
 603        cd "$1" &&
 604        case "$2" in
 605        '')
 606                git fetch ;;
 607        *)
 608                git fetch $(get_default_remote) "$2" ;;
 609        esac
 610)
 611
 612#
 613# Update each submodule path to correct revision, using clone and checkout as needed
 614#
 615# $@ = requested paths (default to all)
 616#
 617cmd_update()
 618{
 619        # parse $args after "submodule ... update".
 620        while test $# -ne 0
 621        do
 622                case "$1" in
 623                -q|--quiet)
 624                        GIT_QUIET=1
 625                        ;;
 626                -i|--init)
 627                        init=1
 628                        ;;
 629                --remote)
 630                        remote=1
 631                        ;;
 632                -N|--no-fetch)
 633                        nofetch=1
 634                        ;;
 635                -f|--force)
 636                        force=$1
 637                        ;;
 638                -r|--rebase)
 639                        update="rebase"
 640                        ;;
 641                --reference)
 642                        case "$2" in '') usage ;; esac
 643                        reference="--reference=$2"
 644                        shift
 645                        ;;
 646                --reference=*)
 647                        reference="$1"
 648                        ;;
 649                -m|--merge)
 650                        update="merge"
 651                        ;;
 652                --recursive)
 653                        recursive=1
 654                        ;;
 655                --checkout)
 656                        update="checkout"
 657                        ;;
 658                --depth)
 659                        case "$2" in '') usage ;; esac
 660                        depth="--depth=$2"
 661                        shift
 662                        ;;
 663                --depth=*)
 664                        depth=$1
 665                        ;;
 666                --)
 667                        shift
 668                        break
 669                        ;;
 670                -*)
 671                        usage
 672                        ;;
 673                *)
 674                        break
 675                        ;;
 676                esac
 677                shift
 678        done
 679
 680        if test -n "$init"
 681        then
 682                cmd_init "--" "$@" || return
 683        fi
 684
 685        cloned_modules=
 686        git submodule--helper list --prefix "$wt_prefix" "$@" | {
 687        err=
 688        while read mode sha1 stage sm_path
 689        do
 690                die_if_unmatched "$mode"
 691                if test "$stage" = U
 692                then
 693                        echo >&2 "Skipping unmerged submodule $prefix$sm_path"
 694                        continue
 695                fi
 696                name=$(git submodule--helper name "$sm_path") || exit
 697                url=$(git config submodule."$name".url)
 698                branch=$(get_submodule_config "$name" branch master)
 699                if ! test -z "$update"
 700                then
 701                        update_module=$update
 702                else
 703                        update_module=$(git config submodule."$name".update)
 704                        if test -z "$update_module"
 705                        then
 706                                update_module="checkout"
 707                        fi
 708                fi
 709
 710                displaypath=$(relative_path "$prefix$sm_path")
 711
 712                if test "$update_module" = "none"
 713                then
 714                        echo "Skipping submodule '$displaypath'"
 715                        continue
 716                fi
 717
 718                if test -z "$url"
 719                then
 720                        # Only mention uninitialized submodules when its
 721                        # path have been specified
 722                        test "$#" != "0" &&
 723                        say "$(eval_gettext "Submodule path '\$displaypath' not initialized
 724Maybe you want to use 'update --init'?")"
 725                        continue
 726                fi
 727
 728                if ! test -d "$sm_path"/.git && ! test -f "$sm_path"/.git
 729                then
 730                        git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$prefix" --path "$sm_path" --name "$name" --url "$url" "$reference" "$depth" || exit
 731                        cloned_modules="$cloned_modules;$name"
 732                        subsha1=
 733                else
 734                        subsha1=$(clear_local_git_env; cd "$sm_path" &&
 735                                git rev-parse --verify HEAD) ||
 736                        die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
 737                fi
 738
 739                if test -n "$remote"
 740                then
 741                        if test -z "$nofetch"
 742                        then
 743                                # Fetch remote before determining tracking $sha1
 744                                (clear_local_git_env; cd "$sm_path" && git-fetch) ||
 745                                die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
 746                        fi
 747                        remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
 748                        sha1=$(clear_local_git_env; cd "$sm_path" &&
 749                                git rev-parse --verify "${remote_name}/${branch}") ||
 750                        die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
 751                fi
 752
 753                if test "$subsha1" != "$sha1" || test -n "$force"
 754                then
 755                        subforce=$force
 756                        # If we don't already have a -f flag and the submodule has never been checked out
 757                        if test -z "$subsha1" && test -z "$force"
 758                        then
 759                                subforce="-f"
 760                        fi
 761
 762                        if test -z "$nofetch"
 763                        then
 764                                # Run fetch only if $sha1 isn't present or it
 765                                # is not reachable from a ref.
 766                                is_tip_reachable "$sm_path" "$sha1" ||
 767                                fetch_in_submodule "$sm_path" ||
 768                                die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
 769
 770                                # Now we tried the usual fetch, but $sha1 may
 771                                # not be reachable from any of the refs
 772                                is_tip_reachable "$sm_path" "$sha1" ||
 773                                fetch_in_submodule "$sm_path" "$sha1" ||
 774                                die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
 775                        fi
 776
 777                        # Is this something we just cloned?
 778                        case ";$cloned_modules;" in
 779                        *";$name;"*)
 780                                # then there is no local change to integrate
 781                                update_module=checkout ;;
 782                        esac
 783
 784                        must_die_on_failure=
 785                        case "$update_module" in
 786                        checkout)
 787                                command="git checkout $subforce -q"
 788                                die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
 789                                say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
 790                                ;;
 791                        rebase)
 792                                command="git rebase"
 793                                die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
 794                                say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
 795                                must_die_on_failure=yes
 796                                ;;
 797                        merge)
 798                                command="git merge"
 799                                die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
 800                                say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
 801                                must_die_on_failure=yes
 802                                ;;
 803                        !*)
 804                                command="${update_module#!}"
 805                                die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
 806                                say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
 807                                must_die_on_failure=yes
 808                                ;;
 809                        *)
 810                                die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
 811                        esac
 812
 813                        if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
 814                        then
 815                                say "$say_msg"
 816                        elif test -n "$must_die_on_failure"
 817                        then
 818                                die_with_status 2 "$die_msg"
 819                        else
 820                                err="${err};$die_msg"
 821                                continue
 822                        fi
 823                fi
 824
 825                if test -n "$recursive"
 826                then
 827                        (
 828                                prefix="$prefix$sm_path/"
 829                                clear_local_git_env
 830                                cd "$sm_path" &&
 831                                eval cmd_update
 832                        )
 833                        res=$?
 834                        if test $res -gt 0
 835                        then
 836                                die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
 837                                if test $res -eq 1
 838                                then
 839                                        err="${err};$die_msg"
 840                                        continue
 841                                else
 842                                        die_with_status $res "$die_msg"
 843                                fi
 844                        fi
 845                fi
 846        done
 847
 848        if test -n "$err"
 849        then
 850                OIFS=$IFS
 851                IFS=';'
 852                for e in $err
 853                do
 854                        if test -n "$e"
 855                        then
 856                                echo >&2 "$e"
 857                        fi
 858                done
 859                IFS=$OIFS
 860                exit 1
 861        fi
 862        }
 863}
 864
 865set_name_rev () {
 866        revname=$( (
 867                clear_local_git_env
 868                cd "$1" && {
 869                        git describe "$2" 2>/dev/null ||
 870                        git describe --tags "$2" 2>/dev/null ||
 871                        git describe --contains "$2" 2>/dev/null ||
 872                        git describe --all --always "$2"
 873                }
 874        ) )
 875        test -z "$revname" || revname=" ($revname)"
 876}
 877#
 878# Show commit summary for submodules in index or working tree
 879#
 880# If '--cached' is given, show summary between index and given commit,
 881# or between working tree and given commit
 882#
 883# $@ = [commit (default 'HEAD'),] requested paths (default all)
 884#
 885cmd_summary() {
 886        summary_limit=-1
 887        for_status=
 888        diff_cmd=diff-index
 889
 890        # parse $args after "submodule ... summary".
 891        while test $# -ne 0
 892        do
 893                case "$1" in
 894                --cached)
 895                        cached="$1"
 896                        ;;
 897                --files)
 898                        files="$1"
 899                        ;;
 900                --for-status)
 901                        for_status="$1"
 902                        ;;
 903                -n|--summary-limit)
 904                        summary_limit="$2"
 905                        isnumber "$summary_limit" || usage
 906                        shift
 907                        ;;
 908                --summary-limit=*)
 909                        summary_limit="${1#--summary-limit=}"
 910                        isnumber "$summary_limit" || usage
 911                        ;;
 912                --)
 913                        shift
 914                        break
 915                        ;;
 916                -*)
 917                        usage
 918                        ;;
 919                *)
 920                        break
 921                        ;;
 922                esac
 923                shift
 924        done
 925
 926        test $summary_limit = 0 && return
 927
 928        if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
 929        then
 930                head=$rev
 931                test $# = 0 || shift
 932        elif test -z "$1" || test "$1" = "HEAD"
 933        then
 934                # before the first commit: compare with an empty tree
 935                head=$(git hash-object -w -t tree --stdin </dev/null)
 936                test -z "$1" || shift
 937        else
 938                head="HEAD"
 939        fi
 940
 941        if [ -n "$files" ]
 942        then
 943                test -n "$cached" &&
 944                die "$(gettext "The --cached option cannot be used with the --files option")"
 945                diff_cmd=diff-files
 946                head=
 947        fi
 948
 949        cd_to_toplevel
 950        eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
 951        # Get modified modules cared by user
 952        modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
 953                sane_egrep '^:([0-7]* )?160000' |
 954                while read mod_src mod_dst sha1_src sha1_dst status sm_path
 955                do
 956                        # Always show modules deleted or type-changed (blob<->module)
 957                        if test "$status" = D || test "$status" = T
 958                        then
 959                                printf '%s\n' "$sm_path"
 960                                continue
 961                        fi
 962                        # Respect the ignore setting for --for-status.
 963                        if test -n "$for_status"
 964                        then
 965                                name=$(git submodule--helper name "$sm_path")
 966                                ignore_config=$(get_submodule_config "$name" ignore none)
 967                                test $status != A && test $ignore_config = all && continue
 968                        fi
 969                        # Also show added or modified modules which are checked out
 970                        GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
 971                        printf '%s\n' "$sm_path"
 972                done
 973        )
 974
 975        test -z "$modules" && return
 976
 977        git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
 978        sane_egrep '^:([0-7]* )?160000' |
 979        cut -c2- |
 980        while read mod_src mod_dst sha1_src sha1_dst status name
 981        do
 982                if test -z "$cached" &&
 983                        test $sha1_dst = 0000000000000000000000000000000000000000
 984                then
 985                        case "$mod_dst" in
 986                        160000)
 987                                sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
 988                                ;;
 989                        100644 | 100755 | 120000)
 990                                sha1_dst=$(git hash-object $name)
 991                                ;;
 992                        000000)
 993                                ;; # removed
 994                        *)
 995                                # unexpected type
 996                                eval_gettextln "unexpected mode \$mod_dst" >&2
 997                                continue ;;
 998                        esac
 999                fi
1000                missing_src=
1001                missing_dst=
1002
1003                test $mod_src = 160000 &&
1004                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1005                missing_src=t
1006
1007                test $mod_dst = 160000 &&
1008                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1009                missing_dst=t
1010
1011                display_name=$(relative_path "$name")
1012
1013                total_commits=
1014                case "$missing_src,$missing_dst" in
1015                t,)
1016                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_src")"
1017                        ;;
1018                ,t)
1019                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_dst")"
1020                        ;;
1021                t,t)
1022                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1023                        ;;
1024                *)
1025                        errmsg=
1026                        total_commits=$(
1027                        if test $mod_src = 160000 && test $mod_dst = 160000
1028                        then
1029                                range="$sha1_src...$sha1_dst"
1030                        elif test $mod_src = 160000
1031                        then
1032                                range=$sha1_src
1033                        else
1034                                range=$sha1_dst
1035                        fi
1036                        GIT_DIR="$name/.git" \
1037                        git rev-list --first-parent $range -- | wc -l
1038                        )
1039                        total_commits=" ($(($total_commits + 0)))"
1040                        ;;
1041                esac
1042
1043                sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1044                sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1045                if test $status = T
1046                then
1047                        blob="$(gettext "blob")"
1048                        submodule="$(gettext "submodule")"
1049                        if test $mod_dst = 160000
1050                        then
1051                                echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1052                        else
1053                                echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1054                        fi
1055                else
1056                        echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1057                fi
1058                if test -n "$errmsg"
1059                then
1060                        # Don't give error msg for modification whose dst is not submodule
1061                        # i.e. deleted or changed to blob
1062                        test $mod_dst = 160000 && echo "$errmsg"
1063                else
1064                        if test $mod_src = 160000 && test $mod_dst = 160000
1065                        then
1066                                limit=
1067                                test $summary_limit -gt 0 && limit="-$summary_limit"
1068                                GIT_DIR="$name/.git" \
1069                                git log $limit --pretty='format:  %m %s' \
1070                                --first-parent $sha1_src...$sha1_dst
1071                        elif test $mod_dst = 160000
1072                        then
1073                                GIT_DIR="$name/.git" \
1074                                git log --pretty='format:  > %s' -1 $sha1_dst
1075                        else
1076                                GIT_DIR="$name/.git" \
1077                                git log --pretty='format:  < %s' -1 $sha1_src
1078                        fi
1079                        echo
1080                fi
1081                echo
1082        done
1083}
1084#
1085# List all submodules, prefixed with:
1086#  - submodule not initialized
1087#  + different revision checked out
1088#
1089# If --cached was specified the revision in the index will be printed
1090# instead of the currently checked out revision.
1091#
1092# $@ = requested paths (default to all)
1093#
1094cmd_status()
1095{
1096        # parse $args after "submodule ... status".
1097        while test $# -ne 0
1098        do
1099                case "$1" in
1100                -q|--quiet)
1101                        GIT_QUIET=1
1102                        ;;
1103                --cached)
1104                        cached=1
1105                        ;;
1106                --recursive)
1107                        recursive=1
1108                        ;;
1109                --)
1110                        shift
1111                        break
1112                        ;;
1113                -*)
1114                        usage
1115                        ;;
1116                *)
1117                        break
1118                        ;;
1119                esac
1120                shift
1121        done
1122
1123        git submodule--helper list --prefix "$wt_prefix" "$@" |
1124        while read mode sha1 stage sm_path
1125        do
1126                die_if_unmatched "$mode"
1127                name=$(git submodule--helper name "$sm_path") || exit
1128                url=$(git config submodule."$name".url)
1129                displaypath=$(relative_path "$prefix$sm_path")
1130                if test "$stage" = U
1131                then
1132                        say "U$sha1 $displaypath"
1133                        continue
1134                fi
1135                if test -z "$url" ||
1136                {
1137                        ! test -d "$sm_path"/.git &&
1138                        ! test -f "$sm_path"/.git
1139                }
1140                then
1141                        say "-$sha1 $displaypath"
1142                        continue;
1143                fi
1144                if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1145                then
1146                        set_name_rev "$sm_path" "$sha1"
1147                        say " $sha1 $displaypath$revname"
1148                else
1149                        if test -z "$cached"
1150                        then
1151                                sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1152                        fi
1153                        set_name_rev "$sm_path" "$sha1"
1154                        say "+$sha1 $displaypath$revname"
1155                fi
1156
1157                if test -n "$recursive"
1158                then
1159                        (
1160                                prefix="$displaypath/"
1161                                clear_local_git_env
1162                                cd "$sm_path" &&
1163                                eval cmd_status
1164                        ) ||
1165                        die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1166                fi
1167        done
1168}
1169#
1170# Sync remote urls for submodules
1171# This makes the value for remote.$remote.url match the value
1172# specified in .gitmodules.
1173#
1174cmd_sync()
1175{
1176        while test $# -ne 0
1177        do
1178                case "$1" in
1179                -q|--quiet)
1180                        GIT_QUIET=1
1181                        shift
1182                        ;;
1183                --recursive)
1184                        recursive=1
1185                        shift
1186                        ;;
1187                --)
1188                        shift
1189                        break
1190                        ;;
1191                -*)
1192                        usage
1193                        ;;
1194                *)
1195                        break
1196                        ;;
1197                esac
1198        done
1199        cd_to_toplevel
1200        git submodule--helper list --prefix "$wt_prefix" "$@" |
1201        while read mode sha1 stage sm_path
1202        do
1203                die_if_unmatched "$mode"
1204                name=$(git submodule--helper name "$sm_path")
1205                url=$(git config -f .gitmodules --get submodule."$name".url)
1206
1207                # Possibly a url relative to parent
1208                case "$url" in
1209                ./*|../*)
1210                        # rewrite foo/bar as ../.. to find path from
1211                        # submodule work tree to superproject work tree
1212                        up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1213                        # guarantee a trailing /
1214                        up_path=${up_path%/}/ &&
1215                        # path from submodule work tree to submodule origin repo
1216                        sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1217                        # path from superproject work tree to submodule origin repo
1218                        super_config_url=$(resolve_relative_url "$url") || exit
1219                        ;;
1220                *)
1221                        sub_origin_url="$url"
1222                        super_config_url="$url"
1223                        ;;
1224                esac
1225
1226                if git config "submodule.$name.url" >/dev/null 2>/dev/null
1227                then
1228                        displaypath=$(relative_path "$prefix$sm_path")
1229                        say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1230                        git config submodule."$name".url "$super_config_url"
1231
1232                        if test -e "$sm_path"/.git
1233                        then
1234                        (
1235                                clear_local_git_env
1236                                cd "$sm_path"
1237                                remote=$(get_default_remote)
1238                                git config remote."$remote".url "$sub_origin_url"
1239
1240                                if test -n "$recursive"
1241                                then
1242                                        prefix="$prefix$sm_path/"
1243                                        eval cmd_sync
1244                                fi
1245                        )
1246                        fi
1247                fi
1248        done
1249}
1250
1251# This loop parses the command line arguments to find the
1252# subcommand name to dispatch.  Parsing of the subcommand specific
1253# options are primarily done by the subcommand implementations.
1254# Subcommand specific options such as --branch and --cached are
1255# parsed here as well, for backward compatibility.
1256
1257while test $# != 0 && test -z "$command"
1258do
1259        case "$1" in
1260        add | foreach | init | deinit | update | status | summary | sync)
1261                command=$1
1262                ;;
1263        -q|--quiet)
1264                GIT_QUIET=1
1265                ;;
1266        -b|--branch)
1267                case "$2" in
1268                '')
1269                        usage
1270                        ;;
1271                esac
1272                branch="$2"; shift
1273                ;;
1274        --cached)
1275                cached="$1"
1276                ;;
1277        --)
1278                break
1279                ;;
1280        -*)
1281                usage
1282                ;;
1283        *)
1284                break
1285                ;;
1286        esac
1287        shift
1288done
1289
1290# No command word defaults to "status"
1291if test -z "$command"
1292then
1293    if test $# = 0
1294    then
1295        command=status
1296    else
1297        usage
1298    fi
1299fi
1300
1301# "-b branch" is accepted only by "add"
1302if test -n "$branch" && test "$command" != add
1303then
1304        usage
1305fi
1306
1307# "--cached" is accepted only by "status" and "summary"
1308if test -n "$cached" && test "$command" != status && test "$command" != summary
1309then
1310        usage
1311fi
1312
1313"cmd_$command" "$@"